/*
  mtetherd
  (c) 2010 Gregor Riepl <onitake@gmail.com>
  
  Tethering utility for Maemo
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MTETHERD_HAL_H
#define _MTETHERD_HAL_H

#include <glib.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <libhal.h>
#include "plugin.h"

// Initialize DBUS and HAL connection
gboolean mtetherd_hal_init(MTetherDStatusPlugin *plugin);
// Release resources required for HAL connection
void mtetherd_hal_finalize(MTetherDStatusPlugin *plugin);
// Scan the HAL network interface list and call
// mtetherd_status_plugin_device_added() for each device
void mtetherd_hal_device_scan(MTetherDStatusPlugin *plugin);
// Check the USB cable state
// Returns TRUE if plugged in, FALSE if not
gboolean mtetherd_usb_state(MTetherDStatusPlugin *plugin);

#endif //_MTETHERD_HAL_H

