# mtetherd
# (c) 2010 Gregor Riepl <onitake@gmail.com>
# 
# Tethering utility for Maemo
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

INTERFACE=$1
WAN=$2

log() {
	echo $@
	echo $(date): $@ >> /tmp/mtetherd-script.log
}

die() {
	echo $@ >&2
	echo $(date): $@ >> /tmp/mtetherd-script.log
	exit 1
}

if [ "${INTERFACE}" = "" ]; then
	die "Usage: $0 <interface> [<wan interface>]"
fi

log "Shutting down routing for: ${INTERFACE} ${WAN}"

echo "${INTERFACE}" | grep -E -q '^[a-zA-Z]+[0-9]+$' || die "Invalid interface name"
if [ "${WAN}" != "" ]; then
	echo "${WAN}" | grep -E -q '^[a-zA-Z]+[0-9]+$' || die "Invalid WAN interface name"
fi

RUNFILE="/var/run/mtetherd.${INTERFACE}.pid"

log "echo 0 > /proc/sys/net/ipv4/conf/${INTERFACE}/forwarding"
echo 0 > /proc/sys/net/ipv4/conf/${INTERFACE}/forwarding
log "/sbin/start-stop-daemon -K -p \"${RUNFILE}\" -x /usr/sbin/dnsmasq"
msg=$(/sbin/start-stop-daemon -K -p "${RUNFILE}" -x /usr/sbin/dnsmasq 2>&1)
log "$msg"
if [ "${WAN}" != "" ]; then
	log "/usr/sbin/iptables -t nat -D POSTROUTING -o ${WAN} -j MASQUERADE"
	msg=$(/usr/sbin/iptables -t nat -D POSTROUTING -o ${WAN} -j MASQUERADE 2>&1)
	log $msg
fi

log "Finished shutting down routing for ${INTERFACE}"

