/*
  mtetherd
  (c) 2010 Gregor Riepl <onitake@gmail.com>
  
  Tethering utility for Maemo
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MTETHERD_STATUS_H
#define _MTETHERD_STATUS_H

#include <libhal.h>
#include <libhildondesktop/libhildondesktop.h>
#include "net.h"

G_BEGIN_DECLS

// The logging domain for Glib log messages
const char *MTETHERD_LOG_DOMAIN;

#define TYPE_MTETHERD_STATUS_PLUGIN (mtetherd_status_plugin_get_type())
#define MTETHERD_STATUS_PLUGIN(object) (G_TYPE_CHECK_INSTANCE_CAST((object), TYPE_MTETHERD_STATUS_PLUGIN, MTetherDStatusPlugin))
#define MTETHERD_STATUS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), TYPE_MTETHERD_STATUS_PLUGIN, MTetherDStatusPluginClass))
#define IS_MTETHERD_STATUS_PLUGIN(object) (G_TYPE_CHECK_INSTANCE_TYPE((object), TYPE_MTETHERD_STATUS_PLUGIN))
#define IS_MTETHERD_STATUS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), TYPE_MTETHERD_STATUS_PLUGIN))
#define MTETHERD_STATUS_PLUGIN_GET_CLASS(object) (G_TYPE_INSTANCE_GET_CLASS((object), TYPE_MTETHERD_STATUS_PLUGIN, MTetherDStatusPluginClass))

typedef struct _MTetherDStatusPluginClass MTetherDStatusPluginClass;
typedef struct _MTetherDStatusPlugin MTetherDStatusPlugin;
typedef struct _MTetherDStatusPluginPrivate MTetherDStatusPluginPrivate;

struct _MTetherDStatusPluginClass {
	HDStatusMenuItemClass parent;
};

struct _MTetherDStatusPlugin {
	HDStatusMenuItem parent;
	MTetherDStatusPluginPrivate *priv;
	DBusGConnection *dbus_connection;
	LibHalContext *hal_context;
};

GType mtetherd_status_plugin_get_type();

// Network device creation callback
void mtetherd_status_plugin_device_added(MTetherDStatusPlugin *plugin, MTetherDDevice *device);
// Network device removal callback
void mtetherd_status_plugin_device_removed(MTetherDStatusPlugin *plugin, const gchar *udi);
// Signals a USB connection or disconnection event
void mtetherd_status_plugin_usb_plugged(MTetherDStatusPlugin *plugin);

G_END_DECLS

#endif //_MTETHERD_STATUS_H

